﻿using System;
using System.Diagnostics;
using System.IO;
using System.Text;
using System.Net.WebSockets;
using System.Threading.Tasks;
using System.Threading;

namespace _2dxAutoClip_NET
{
    internal class Program //get .NET'd stinky
    {
        
        private static readonly string websocketAddress = "localhost";
        private static readonly int websocketPort = 10573;
        public static ffmpegAPI _ffmpeg = new ffmpegAPI();
        

        static async Task Main(string[] args)
        {
            Process[] spiceProcesses = Process.GetProcessesByName("spice64");

            if (spiceProcesses.Length > 0)
            {
                Console.WriteLine("Found spice64.exe running, proceeding to connect to TickerHookWS...");
                await Connect2Websocket();
            }
            else
            {
                Console.WriteLine("spice64.exe is not running.");
            }

        }

        public static string GetPathFile()
        {
            string wanted_path = $"{File.ReadAllText($@"{Environment.CurrentDirectory}\conf\path.txt")}"; //@"E:\autorecording"
            if (Directory.Exists(wanted_path.Replace(@"\path.txt", "")))
            {
                return wanted_path;
            }
            else
            {
                return $@"C:\Users\{Environment.UserName}\Videos";
            }
        }

        public static async Task Connect2Websocket()
        {
            int maxretry = 5;
            int attempt = 0;

            while (attempt < maxretry) 
            {
                attempt++;
                Console.WriteLine($"Attempt: {attempt} of {maxretry}");

                bool succ = await ConnectWebSocket();

                if (succ)
                {
                    break;
                }
                else if (attempt < maxretry)
                {
                    Console.WriteLine($"Retrying in 10 seconds... {maxretry - attempt} attempts remaining.");
                    await Task.Delay(10000);
                }
                else if (attempt == maxretry)
                {
                    Console.WriteLine("Failed to connect after 5 attempts..");
                }
            }
        }

        public static async Task<bool> ConnectWebSocket()
        {
            var tickerUri = new Uri($"ws://{websocketAddress}:{websocketPort}");
            var reconnecting = false;

            var lastMessage = string.Empty;
            var consecutiveMessageCount = 0;
            var isRecording = false;
            var currentSongName = string.Empty;

            var shouldCheckForMusicSelect = false;

            var clientWebSocket = new ClientWebSocket();
            try
            {
                await clientWebSocket.ConnectAsync(tickerUri, CancellationToken.None);
                Console.WriteLine("Connected to TickerHook WebSocket.");
            }
            catch (Exception ex)
            {
                Console.WriteLine($"Error connecting to TickerHook WebSocket: {ex.Message}");
                return false; // Indicate connection failure
            }

            var buffer = new byte[1024];

            while (clientWebSocket.State == WebSocketState.Open)
            {
                WebSocketReceiveResult result;
                try
                {
                    result = await clientWebSocket.ReceiveAsync(new ArraySegment<byte>(buffer), CancellationToken.None);
                }
                catch (Exception ex)
                {
                    Console.WriteLine($"Error receiving message: {ex.Message}");
                    reconnecting = true;
                    break;
                }

                var message = Encoding.UTF8.GetString(buffer, 0, result.Count).Trim().ToUpper();
                Console.WriteLine($"Received message: {message}");

                if (message == lastMessage && !message.Contains("SELECT FROM"))
                {
                    consecutiveMessageCount++;
                }
                else
                {
                    consecutiveMessageCount = 1;
                    lastMessage = message;
                }

                if (consecutiveMessageCount >= 2 && !message.Contains("SELECT FROM") && !isRecording)
                {
                    currentSongName = message;
                    Console.WriteLine("Starting recording...");
                    _ffmpeg.StartRecording(currentSongName);
                    isRecording = true;
                }

                if (isRecording)
                {
                    if (shouldCheckForMusicSelect && message.Contains("MUSIC SELECT!!"))
                    {
                        Console.WriteLine("Stopping recording...");
                        _ffmpeg.StopRecording(currentSongName);
                        isRecording = false;
                        shouldCheckForMusicSelect = false;
                    }
                    else if (message.EndsWith("CLEAR!") || message.EndsWith("FAILED.."))
                    {
                        shouldCheckForMusicSelect = true;
                    }
                }
            }

            return !reconnecting;
        }
    }
}
